> ## Documentation Index
> Fetch the complete documentation index at: https://developers.fireblocks.com/llms.txt
> Use this file to discover all available pages before exploring further.

<AgentInstructions>

## Submitting Feedback

If you encounter incorrect, outdated, or confusing documentation on this page, submit feedback:

POST https://developers.fireblocks.com/feedback

```json
{
  "path": "/api-reference/policy-editor-beta/send-publish-request-for-a-certain-draft-id",
  "feedback": "Description of the issue"
}
```

Only submit feedback when you have something specific and actionable to report.

</AgentInstructions>

# Send publish request for a certain draft id

> Legacy Endpoint – Send publish request of certain draft id and returns the response. 
**Note:** 
- This endpoint will remain available for the foreseeable future and is not deprecated. - The `publishDraft` endpoint under policy/paths provides improved functionality and better performance. - These endpoints are currently in beta and might be subject to changes.
If you want to participate and learn more about the Fireblocks TAP, please contact your Fireblocks Customer Success Manager or send an email to CSM@fireblocks.com.




## OpenAPI

````yaml https://docs.fireblocks.com/api/v1/swagger.yaml post /tap/draft
openapi: 3.0.0
info:
  title: Fireblocks API
  description: >
    Fireblocks provides a suite of applications to manage digital asset
    operations and a complete development platform to build your business on the
    blockchain.


    - Visit our website for more information: [Fireblocks
    Website](https://fireblocks.com)

    - Visit our developer docs: [Fireblocks
    DevPortal](https://developers.fireblocks.com)
  version: 1.6.2
  contact:
    email: developers@fireblocks.com
servers:
  - url: https://api.fireblocks.io/v1
    description: Fireblocks Production Environment Base URL
  - url: https://sandbox-api.fireblocks.io/v1
    description: Fireblocks Sandbox Environment Base URL
security: []
paths:
  /tap/draft:
    post:
      tags:
        - Policy Editor (Beta)
      summary: Send publish request for a certain draft id
      description: >
        Legacy Endpoint – Send publish request of certain draft id and returns
        the response. 

        **Note:** 

        - This endpoint will remain available for the foreseeable future and is
        not deprecated. - The `publishDraft` endpoint under policy/paths
        provides improved functionality and better performance. - These
        endpoints are currently in beta and might be subject to changes.

        If you want to participate and learn more about the Fireblocks TAP,
        please contact your Fireblocks Customer Success Manager or send an email
        to CSM@fireblocks.com.
      operationId: publishDraftLegacy
      parameters:
        - $ref: '#/components/parameters/X-Idempotency-Key'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LegacyPublishDraftRequest'
      responses:
        '201':
          description: A policy publish result object
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LegacyPublishResult'
        default:
          $ref: '#/components/responses/Error'
      x-codeSamples:
        - lang: TypeScript
          source: >-
            const response: Promise<FireblocksResponse<LegacyPublishResult>> =
            fireblocks.policyEditorBeta.publishDraftLegacy(policyEditorBetaApiPublishDraftLegacyRequest);
        - lang: Java
          source: >-
            CompletableFuture<ApiResponse<LegacyPublishResult>> response =
            fireblocks.policyEditorBeta().publishDraftLegacy(legacyPublishDraftRequest,
            idempotencyKey);
        - lang: Python
          source: >-
            response =
            fireblocks.policy_editor_beta.publish_draft_legacy(legacy_publish_draft_request,
            idempotency_key);
components:
  parameters:
    X-Idempotency-Key:
      name: Idempotency-Key
      in: header
      description: >-
        A unique identifier for the request. If the request is sent multiple
        times with the same idempotency key, the server will return the same
        response as the first request. The idempotency key is valid for 24
        hours.
      required: false
      schema:
        type: string
  schemas:
    LegacyPublishDraftRequest:
      type: object
      properties:
        draftId:
          description: draft unique identifier
          type: string
    LegacyPublishResult:
      type: object
      description: Response object of the publish policy operation
      properties:
        status:
          $ref: '#/components/schemas/LegacyPolicyStatus'
        rules:
          type: array
          items:
            $ref: '#/components/schemas/LegacyPolicyRule'
        checkResult:
          $ref: '#/components/schemas/LegacyPolicyCheckResult'
        metadata:
          $ref: '#/components/schemas/LegacyPolicyMetadata'
      required:
        - status
        - rules
        - checkResult
        - metadata
    LegacyPolicyStatus:
      type: string
      enum:
        - SUCCESS
        - UNVALIDATED
        - INVALID_CONFIGURATION
        - PENDING
        - PENDING_CONSOLE_APPROVAL
        - AWAITING_QUORUM
        - UNHANDLED_ERROR
      description: |
        * SUCCESS - success
        * UNVALIDATED - not validated yet
        * INVALID_CONFIGURATION - at least one rule is invalid
        * PENDING - pending approval
        * PENDING_CONSOLE_APPROVAL - pending approval from the console app
        * AWAITING_QUORUM - pending quorum approval
        * UNHANDLED_ERROR - unhandled error
    LegacyPolicyRule:
      type: object
      description: Policy rule which is enforced on transactions
      properties:
        operator:
          type: string
          description: >-
            (deprecated - replaced by "operators")  | Defines users who can
            initiate the type of transaction to which the rule applies. options
            are * "*" - All users are allowed * Specific User id
          deprecated: true
        operators:
          type: object
          description: >-
            Defines users/groups who can initiate the type of transaction to
            which the rule applies.
          properties:
            wildcard:
              type: string
              enum:
                - '*'
              description: >
                If used then this property should appear as the only child
                property

                * "*" - All users are allowed
            users:
              type: array
              description: Set of users ids
              items:
                type: string
            usersGroups:
              type: array
              description: Set of group ids
              items:
                type: string
            services:
              type: array
              description: set of services to initiate transactions
              items:
                type: string
        transactionType:
          type: string
          enum:
            - TRANSFER
            - CONTRACT_CALL
            - APPROVE
            - MINT
            - BURN
            - SUPPLY
            - REDEEM
            - STAKE
            - RAW
            - TYPED_MESSAGE
            - PROGRAM_CALL
          description: |
            Defines the type of transaction to which the rule applies.
              * TRANSFER - Default. Transfers funds from one account to another
              * CONTRACT_CALL - Calls a smart contract, mainly for DeFi operations.
              * APPROVE - Allows a smart contract to withdraw from a designated wallet.
              * MINT - Perform a mint operation (increase supply) on a supported token
              * BURN - Perform a burn operation (reduce supply) on a supported token
              * SUPPLY - Use for DeFi to lend assets
              * REDEEM - Use for DeFi to get lending back
              * STAKE - Allows you to allocate and lock certain assets for earning staking rewards.
              * RAW - An off-chain message with no predefined format, use it to sign any message with your private key.
              * TYPED_MESSAGE - An off-chain message type that follows a predefined format, used to sign specific messages that are not actual transactions.
              * PROGRAM_CALL - In Solana refers to invoking on-chain programs (smart contracts) to execute transactions and interact with the blockchain.
        designatedSigner:
          type: string
          description: >-
            (deprecated - replaced by "designatedSigners") Id representing the
            user who signs transactions that match a specific rule
          deprecated: true
        designatedSigners:
          type: object
          description: >-
            Set of ids representing the users who signs transactions that match
            a specific rule
          properties:
            users:
              type: array
              description: Set of users ids
              items:
                type: string
            usersGroups:
              type: array
              description: Set of group ids
              items:
                type: string
        type:
          type: string
          description: Policy rule type
          enum:
            - TRANSFER
        action:
          type: string
          enum:
            - ALLOW
            - BLOCK
            - 2-TIER
          description: >
            Defines what occurs when a transaction meets the rule's criteria

            * ALLOW - The transaction goes through and can be signed without
            requiring additional approvals

            * BLOCK - The transaction is automatically blocked

            * 2-TIER - Only these users or user groups can approve 
                       If any of them reject the transaction before the required approval threshold is met, the transaction doesn't go through
                       The list of entities are set is "authorizationGroups" field
        asset:
          type: string
          description: |
            Defines the type of asset being transacted, options are
            * "*" - All assets
            * Specific asset
        srcType:
          description: (deprecated - replaced by "src") source account type
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestType'
        srcSubType:
          description: (deprecated - replaced by "src") source sub account type
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestSubType'
        srcId:
          description: (deprecated - replaced by "src") source account id
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestId'
        src:
          type: object
          description: Defines source accounts the rule allows transfers to originate from
          properties:
            ids:
              type: array
              description: A set of ids in a tuple format
              items:
                $ref: '#/components/schemas/LegacySrcOrDestAttributes'
        dstType:
          description: (deprecated - replaced by "dst") destination account type
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestType'
        dstSubType:
          description: (deprecated - replaced by "dst") destination sub account type
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestSubType'
        dstId:
          description: (deprecated - replaced by "dst") destination account id
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/LegacyPolicySrcOrDestId'
        dst:
          type: object
          description: Defines the destination accounts the rule allows transfers to
          properties:
            ids:
              type: array
              description: A set of ids in a tuple format
              items:
                $ref: '#/components/schemas/LegacySrcOrDestAttributes'
        dstAddressType:
          type: string
          enum:
            - WHITELISTED
            - ONE_TIME
            - '*'
          description: >
            Defines whether the destination to which you are sending funds must
            be whitelisted, to allow one-time transfers to non-whitelisted
            external addresses, or both.

            By default, you can only transfer to an external address after it’s
            whitelisted.
              * WHITELISTED - Can only be sent to whitelisted addresses.
              * ONE_TIME - Can only be sent to non-whitelisted external addresses.
              * "*" - can be sent to whitelisted addresses or non-whitelisted external
        amountCurrency:
          type: string
          enum:
            - USD
            - EUR
            - NATIVE
          description: >
            * USD - Limits the amount of any asset users can transfer based on
            the USD equivalent of the asset.

            * EUR - Limits the amount of any asset users can transfer based on
            the EURO equivalent of the asset.

            * NATIVE - Limits the amount of an asset a user can transfer when
            using a specific asset.
        amountScope:
          type: string
          enum:
            - SINGLE_TX
            - TIMEFRAME
          description: >
            * SINGLE_TX - limit applies to a single transaction

            * TIMEFRAME - limit applies to all transactions within the defined
            time period
        amount:
          description: >-
            Defines the value a transaction must exceed for the rule to apply to
            it (according to the amountCurrency field)
          anyOf:
            - type: string
              description: Numeric string (recommended)
            - type: number
              description: Number (deprecated)
        periodSec:
          type: number
          description: >
            Time period in seconds applied by the amountScope field to
            accumulate transferred amounts in transactions that match the rule,
            until the total exceeds the value you specify under Minimum.

            When the specified amount is reached within that period, whether by
            one or many transactions, further transactions in that period either
            fail or require more approvals.
        authorizers:
          type: array
          description: >-
            (deprecated - replaced by "authorizationGroups") Allowed entities
            which can approves a transaction
          deprecated: true
          items:
            type: string
        authorizersCount:
          type: number
          description: >-
            (deprecated - replaced by "authorizationGroups") Min amount of
            entities which are needed to approve a transaction
          deprecated: true
        authorizationGroups:
          type: object
          description: Defines the transaction approval terms
          properties:
            logic:
              type: string
              enum:
                - AND
                - OR
              description: >
                * AND - requires approval of all authorization groups

                * OR - requires approval of at least one of the authorization
                groups
            allowOperatorAsAuthorizer:
              type: boolean
              description: >-
                Defines whether the user who initiates a transaction can approve
                their own transaction and count toward the approval threshold
                for their transaction
            groups:
              type: array
              description: Groups of entities which can approve the transaction
              items:
                type: object
                properties:
                  users:
                    type: array
                    description: User ids
                    items:
                      type: string
                  usersGroups:
                    type: array
                    description: Group ids
                    items:
                      type: string
                  th:
                    type: number
                    description: >-
                      Represents the min amount of entities which are required
                      to approve the transaction, default is 1.
        amountAggregation:
          type: object
          description: >
            Defines the method by which the Policy Engine calculates
            accumulation.

            It uses the Initiator, Source, and Destination to calculate
            accumulation toward the value under Minimum, for the time under Time
            Period.
          properties:
            operators:
              $ref: '#/components/schemas/LegacyAmountAggregationTimePeriodMethod'
            srcTransferPeers:
              $ref: '#/components/schemas/LegacyAmountAggregationTimePeriodMethod'
            dstTransferPeers:
              $ref: '#/components/schemas/LegacyAmountAggregationTimePeriodMethod'
        rawMessageSigning:
          type: object
          description: Raw message signing configuration
          properties:
            algorithm:
              type: string
            derivationPath:
              type: object
              properties:
                path:
                  type: array
                  items:
                    type: number
        applyForApprove:
          type: boolean
          description: >-
            Applying this rule over APPROVE type transactions (can only be
            enabled when rule's transaction type is TRANSFER)
        applyForTypedMessage:
          type: boolean
          description: >-
            Applying this rule over TYPED_MESSAGE type transactions (can only be
            enabled when rule's transaction type is CONTRACT_CALL)
        externalDescriptor:
          type: string
          description: A unique id identifying the rule
      required:
        - type
        - action
        - asset
        - amountCurrency
        - amountScope
        - amount
        - periodSec
    LegacyPolicyCheckResult:
      type: object
      description: Policy rules validation result
      properties:
        errors:
          type: number
          description: Number of errors
        results:
          type: array
          description: A set of validation results
          items:
            $ref: '#/components/schemas/LegacyPolicyRuleCheckResult'
      required:
        - errors
        - results
    LegacyPolicyMetadata:
      type: object
      description: Policy related metadata
      properties:
        editedBy:
          type: string
          description: The user id of the user who last edited the policy
        editedAt:
          type: string
          description: The timestamp of the last edit of the policy
        publishedBy:
          type: string
          description: The user id of the user who last published the policy
        publishedAt:
          type: string
          description: The timestamp of the last publish of the policy
    ErrorSchema:
      type: object
      properties:
        message:
          type: string
        code:
          type: number
    LegacyPolicySrcOrDestType:
      type: string
      enum:
        - EXCHANGE
        - UNMANAGED
        - VAULT
        - NETWORK_CONNECTION
        - COMPOUND
        - FIAT_ACCOUNT
        - ONE_TIME_ADDRESS
        - '*'
      description: >
        * EXCHANGE - A third-party exchange account connected to your workspace

        * UNMANAGED - A unmanaged wallet outside of Fireblocks workspace

        * VAULT - An account in your Fireblocks Vault

        * NETWORK_CONNECTION - A connection in your Fireblocks network

        * COMPOUND - (deprecated) An asset retrieved by using the Compound DeFI
        protocol

        * FIAT_ACCOUNT - A third-party fiat account connected to your workspace

        * ONE_TIME_ADDRESS - A non-whitelisted asset from your Fireblocks
        Workspace

        * "*" - All types
    LegacyPolicySrcOrDestSubType:
      type: string
      enum:
        - EXTERNAL
        - INTERNAL
        - CONTRACT
        - EXCHANGETEST
        - '*'
      description: >
        * EXTERNAL - A whitelisted wallet assigned as external is typically used
        for addresses managed by your clients and counterparties

        * INTERNAL - A whitelisted wallet assigned as internal, is typically
        used for addresses that you control outside of your Fireblocks workspace

        * CONTRACT - A whitelisted wallet assigned as contract is for
        identifying and managing external smart contracts

        * EXCHANGETEST - Exchanges which operate only on testnet assets

        * "*" - All subtypes
    LegacyPolicySrcOrDestId:
      type: string
      description: |
        Defines the account id, options are
        * "*" - All accounts
        * Specific account id
    LegacySrcOrDestAttributes:
      type: array
      description: >
        Defines source or destination component, options are:

        * id only

        * id and type - first item in the array MUST be id.

        * id, type and subtype - first item in the array MUST be id and second
        item MUST be type.
      items:
        anyOf:
          - $ref: '#/components/schemas/LegacyPolicySrcOrDestId'
          - $ref: '#/components/schemas/LegacyPolicySrcOrDestType'
          - $ref: '#/components/schemas/LegacyPolicySrcOrDestSubType'
      minItems: 1
      maxItems: 3
    LegacyAmountAggregationTimePeriodMethod:
      type: string
      enum:
        - PER_SINGLE_MATCH
        - ACROSS_ALL_MATCHES
      description: |
        * PER_SINGLE_MATCH - Apply the limit to each listed entity
        * ACROSS_ALL_MATCHES - Apply the limit to the sum of all listed entities
    LegacyPolicyRuleCheckResult:
      type: object
      description: The rule validation result
      properties:
        index:
          type: number
          description: Rule index number in the policy
        status:
          type: string
          description: Validation status
          enum:
            - ok
            - failure
        errors:
          type: array
          description: A set of rule validation error objects
          items:
            $ref: '#/components/schemas/LegacyPolicyRuleError'
      required:
        - index
        - status
        - errors
    LegacyPolicyRuleError:
      type: object
      description: Rule validation result error
      properties:
        errorMessage:
          type: string
          description: Error message
        errorCode:
          type: number
          description: error code
        errorCodeName:
          type: string
          description: error code name
        errorField:
          type: string
          enum:
            - operator
            - operators
            - authorizationGroups
            - designatedSigner
            - designatedSigners
            - contractMethods
            - amountAggregation
            - src
            - dst
          description: |
            The field which the error relates to
            * operator - transaction initiator
            * operators - transaction initiators
            * authorizationGroups - transaction authorizer groups
            * designatedSigner - transaction signer
            * designatedSigners - transaction signers
            * contractMethods - contract methods
            * amountAggregation - transaction amount aggregation configuration
            * src - transaction source asset configuration
            * dst - transaction destination asset configuration
      required:
        - errorMessage
        - errorCode
        - errorCodeName
        - errorField
  headers:
    X-Request-ID:
      schema:
        type: string
      description: >-
        Unique ID correlated to the API request. Please provide it in any
        support ticket you create or on Github issues related to Fireblocks SDKs
  responses:
    Error:
      description: Error Response
      headers:
        X-Request-ID:
          $ref: '#/components/headers/X-Request-ID'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorSchema'

````